//
//  AKCocoaPhotoMachine.m
//  ScreenshotDemo
//
//  Created by Adrian on 1/27/07.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import "AKNSWindowHackPhotoMachine.h"


@implementation AKNSWindowHackPhotoMachine

// Taken from http://www.cocoadev.com/index.pl?ScreenShotCode
// and from http://developer.apple.com/documentation/Cocoa/Conceptual/CocoaDrawingGuide/Images/chapter_7_section_5.html
// Unfortunately, this code crashes in my own computer... 
// if someone finds out what's wrong, do not hesitate to tell me why!
- (void)takeScreenshot
{
    NSRect rect = [[[NSScreen screens] objectAtIndex:0] frame];
    NSWindow *window;
    NSBitmapImageRep *rep;
	
    window = [[NSWindow alloc] initWithContentRect:rect styleMask:NSBorderlessWindowMask
					backing:NSBackingStoreNonretained defer:NO];
    [window setBackgroundColor:[NSColor clearColor]];
    [window setLevel:NSScreenSaverWindowLevel + 1];
    [window setHasShadow:NO];
    [window setAlphaValue:0.0];
    [window orderFront:self];
    [window setContentView:[[[NSView alloc] initWithFrame:rect] autorelease]];
    [[window contentView] lockFocus];
    rep = [[NSBitmapImageRep alloc] initWithFocusedViewRect:rect];
    [[window contentView] unlockFocus];
    [window orderOut:self];
    [window close];
    
    screenshot = [[[NSImage alloc] initWithSize:rect.size] autorelease];
    [screenshot addRepresentation:rep];
    
    // Notify that we're ready to show the picture
    [[NSNotificationCenter defaultCenter] postNotificationName:AKPhotoHasBeenTaken object:nil];
}

@end
