/* Controller */

#import <Cocoa/Cocoa.h>
#import "AKPhotoMachine.h"

@interface Controller : NSObject
{
    IBOutlet NSMatrix *checkMatrix;
    IBOutlet NSButtonCell *checkFullScreen;
    IBOutlet NSButtonCell *checkSound;
    IBOutlet NSButton *checkHidden;
    IBOutlet NSImageView *imageView;
    IBOutlet NSProgressIndicator *spinningWheel;
    IBOutlet NSButton* saveButton;
    IBOutlet NSWindow* appWindow;
    IBOutlet NSMenuItem* saveMenuItem;
    
    AKPhotoMachine *photoMachine;
}

- (IBAction)grabScreenshot:(id)sender;

- (IBAction) selectWindowHack: (id)sender;
- (IBAction) selectNSTask: (id)sender;
- (IBAction) selectOpenGL: (id)sender;
- (IBAction) selectQuartz: (id)sender;
- (IBAction) selectQuickDraw: (id)sender;
- (IBAction) selectFullScreen: (id)sender;
- (IBAction) selectSound: (id)sender;
- (IBAction) saveImage: (id)sender;

- (void) dealloc;
- (BOOL) applicationShouldTerminateAfterLastWindowClosed: (NSApplication *)theApplication;
- (void) showScreenshot: (NSNotification *)aNotification;

@end
